<template>
  <div class="container">
    <h1 class="display-4">Comments for {{ factoryName }}</h1>

    <div v-if="filteredComments.length > 0">
      <div v-for="comment in filteredComments" :key="comment.id" class="comment-card" @mouseover="hoverComment" @mouseleave="leaveComment">
        <h5>{{ comment.username }}</h5>
        <p><strong>Rating:</strong> {{ comment.rating }} / 5</p>
        <p>{{ comment.text }}</p>
        <p><strong>Status:</strong> {{ comment.status }}</p>

        <!-- Dugme za editovanje statusa komentara, prikazuje se samo menadžeru -->
        <button v-if="isManager" class="custom-btn btn-7" @click="openEditModal(comment)">Edit</button>
      </div>
    </div>
    <div v-else>
      <p>No comments available for this factory.</p>
    </div>

    <!-- Modal za promenu statusa komentara -->
    <div v-if="selectedComment" class="modal">
      <div class="modal-content animate-modal">
        <h3>Edit Comment Status</h3>
        <div class="form-group">
          <label for="status">Status</label>
          <select v-model="selectedComment.status" class="form-control">
            <option value="Pending">Pending</option>
            <option value="Approved">Approved</option>
            <option value="Rejected">Rejected</option>
          </select>
        </div>
        <div class="modal-buttons">
          <button class="custom-btn btn-6" @click="submitStatusChange">Submit</button>
          <button class="custom-btn btn-6-red" @click="closeModal">Cancel</button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  data() {
    return {
      comments: [],
      factoryName: '',
      selectedComment: null, // Trenutno izabrani komentar za editovanje
    };
  },
  computed: {
    isCustomer() {
      const user = JSON.parse(localStorage.getItem('user'));
      return user === 'Kupac';
    },
    isManager() {
      const user = JSON.parse(localStorage.getItem('user'));
      return user === 'Menadzer';
    },
    isAdmin() {
      const user = JSON.parse(localStorage.getItem('user'));
      return user === 'Administrator';
    },
    filteredComments() {
      // Kupci vide samo odobrene komentare
      if (this.isCustomer) {
        return this.comments.filter(comment => comment.status === 'Approved');
      }
      // Menadžeri i administratori vide sve komentare
      if (this.isManager || this.isAdmin) {
        return this.comments;
      }
      return [];
    }
  },
  async created() {
    const factoryId = this.$route.params.factoryId;
    try {
      // Fetch all comments from the server
      const response = await axios.get('http://localhost:3000/comments');
      // Filter comments by factoryId
      this.comments = response.data.filter(comment => comment.factoryId === factoryId);

      // Pretpostavljamo da imate način da povučete naziv fabrike iz baze podataka
      this.factoryName = await this.getFactoryName(factoryId);
    } catch (error) {
      console.error('Error fetching comments:', error);
    }
  },
  methods: {
    async getFactoryName(factoryId) {
      const factoryResponse = await axios.get(`http://localhost:3000/factories/${factoryId}`);
      return factoryResponse.data.name.name;
    },
    openEditModal(comment) {
      this.selectedComment = { ...comment }; // Kopiramo komentar kako bismo radili sa njim
    },
    closeModal() {
      this.selectedComment = null;
    },
    async submitStatusChange() {
      try {
        // Update comment status on the server
        await axios.put(`http://localhost:3000/comments/${this.selectedComment.id}`, this.selectedComment);
        this.closeModal();
        this.fetchComments(); // Ponovo preuzimamo komentare kako bismo ažurirali prikaz
      } catch (error) {
        console.error('Error updating comment status:', error);
      }
    },
    async fetchComments() {
      const factoryId = this.$route.params.factoryId;
      try {
        const response = await axios.get('http://localhost:3000/comments');
        this.comments = response.data.filter(comment => comment.factoryId === factoryId);
      } catch (error) {
        console.error('Error fetching comments:', error);
      }
    }
  }
}
</script>

<style scoped>

.display-4 {
  font-family: 'Lato', sans-serif; /* Promena fonta za moderniji izgled */
  font-size: 3rem; /* Povećavamo veličinu fonta */
  font-weight: 700; /* Bold */
  text-align: center; /* Centriranje teksta */
  color: #333; /* Tamno siva boja teksta */
  margin-bottom: 1.5rem; /* Razmak ispod naslova */
  text-transform: uppercase; /* Velika slova */
  letter-spacing: 2px; /* Proširenje razmaka između slova */
  position: relative; /* Omogućava upotrebu pseudo-elementa za liniju ispod */
}

.display-4::after {
  content: ''; 
  width: 1000px; /* Širina linije */
  height: 4px; /* Debljina linije */
  background-color: #ff7f00; /* Narandžasta linija ispod teksta */
  display: block;
  margin: 10px auto 0; /* Pozicionira liniju ispod teksta */
}

.container {
  padding: 20px;
}

.comment-card {
  border: 1px solid #ccc;
  padding: 10px;
  margin-bottom: 15px;
  border-radius: 5px;
  transition: background-color 1.0S ease, box-shadow 1.0s ease;
  font-family: 'Open Sans', sans-serif;
}

.comment-card:hover {
  background-color: #ffa726; /* Narandžasta boja prilikom hover-a */
  box-shadow: 0px 0px 12px rgba(0, 0, 0, 0.2); /* Blaga senka pri hoveru */
}

/* Stil za modal */
.modal {
  display: flex; 
  justify-content: center; 
  align-items: center; 
  position: fixed; 
  z-index: 1050; 
  left: 0; 
  top: 0; 
  width: 100%; 
  height: 100%; 
  background-color: rgba(0, 0, 0, 0.5);
}

/* Stil za modal-dialog */
.modal-dialog {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100vh; /* Full height */
}

/* Stil za content modala sa animacijom */
.modal-content {
  background-color: #fff;
  position: relative;
  border-radius: 20px;
  padding: 20px;
  box-shadow: 0 0 60px rgba(251, 255, 12, 0.5); /* Blagi sjaj */
  animation: glow-animation 3s infinite alternate, modal-appear 0.5s ease-out;
  width: 70%; /* Smanjujemo širinu modala */
  max-width: 500px; /* Maksimalna širina da modal ne prelazi ovu vrednost */
}

/* Animacija za glowing box */
@keyframes glow-animation {
  from {
    box-shadow: 0 0 20px rgba(142, 61, 2, 0.5), 0 0 30px rgba(255, 186, 33, 0.5);
  }
  to {
    box-shadow: 0 0 40px rgba(255, 186, 33, 1), 0 0 60px rgba(255, 186, 33, 1);
  }
}

/* Animacija za pojavljivanje modala */
@keyframes modal-appear {
  from {
    opacity: 0;
    transform: scale(0.7);
  }
  to {
    opacity: 1;
    transform: scale(1);
  }
}

/* Dugme za zatvaranje */
.btn-close {
  background: none;
  border: none;
  color: #333;
  font-size: 1.5rem;
  cursor: pointer;
}

.btn-close:hover {
  color: rgba(255, 151, 0, 1);
}

/* Header, body i footer unutar modala */
.modal-header {
  display: flex;
  align-items: flex-start;
  justify-content: space-between;
  padding: 1rem;
  border-bottom: 1px solid #dee2e6;
  border-top-left-radius: 0.3rem;
  border-top-right-radius: 0.3rem;
}

.modal-body {
  position: relative;
  flex: 1 1 auto;
  padding: 1rem;
}

.modal-footer {
  display: flex;
  align-items: center;
  justify-content: flex-end;
  padding: 1rem;
  border-top: 1px solid #dee2e6;
  border-bottom-right-radius: 0.3rem;
  border-bottom-left-radius: 0.3rem;
}

button {
  margin: 10px;
}
.custom-btn {
  width: 180px;
  height: 40px;
  color: #fff;
  border-radius: 5px;
  padding: 10px 25px;
  font-family: 'Lato', sans-serif;
  font-weight: 500;
  background: transparent;
  cursor: pointer;
  transition: all 1.0s ease;
  position: relative;
  display: inline-block;
  box-shadow: inset 2px 2px 2px 0px rgba(255,255,255,.5),
              7px 7px 20px 0px rgba(0,0,0,.1),
              4px 4px 5px 0px rgba(0,0,0,.1);
  outline: none;
}

/* 7 */
.btn-7 {
  background: linear-gradient(0deg, rgba(255,151,0,1) 0%, rgba(251,75,2,1) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
}
.btn-7 span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-7:before,
.btn-7:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgba(251,75,2,1);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-7:before {
  height: 0%;
  width: 2px;
}
.btn-7:after {
  width: 0%;
  height: 2px;
}
.btn-7:hover {
  color: rgba(251,75,2,1);
  background: transparent;
}
.btn-7:hover:before {
  height: 100%;
}
.btn-7:hover:after {
  width: 100%;
}
.btn-7 span:before,
.btn-7 span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgba(251,75,2,1);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-7 span:before {
  width: 2px;
  height: 0%;
}
.btn-7 span:after {
  height: 2px;
  width: 0%;
}
.btn-7 span:hover:before {
  height: 100%;
}
.btn-7 span:hover:after {
  width: 100%;
}

/* 6 - Zeleno dugme */
.btn-6 {
  background: linear-gradient(0deg, rgb(42, 156, 43) 0%, rgb(81, 246, 4) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
  color: white;
  border-radius: 5px;
  cursor: pointer;
  position: relative;
  display: inline-block;
  transition: all 0.3s ease;
}
.btn-6 span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-6:before,
.btn-6:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgb(35, 251, 2);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6:before {
  height: 0%;
  width: 2px;
}
.btn-6:after {
  width: 0%;
  height: 2px;
}
.btn-6:hover {
  color: rgb(87, 198, 109);
  background: transparent;
}
.btn-6:hover:before {
  height: 100%;
}
.btn-6:hover:after {
  width: 100%;
}
.btn-6 span:before,
.btn-6 span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgb(2, 251, 139);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6 span:before {
  width: 2px;
  height: 0%;
}
.btn-6 span:after {
  height: 2px;
  width: 0%;
}
.btn-6 span:hover:before {
  height: 100%;
}
.btn-6 span:hover:after {
  width: 100%;
}

/* 6 - Crveno dugme */
.btn-6-red {
  background: linear-gradient(0deg, rgb(220, 53, 69) 0%, rgb(255, 107, 114) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
  color: white;
  border-radius: 5px;
  cursor: pointer;
  position: relative;
  display: inline-block;
  transition: all 0.3s ease;
}
.btn-6-red span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-6-red:before,
.btn-6-red:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgb(255, 80, 80);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6-red:before {
  height: 0%;
  width: 2px;
}
.btn-6-red:after {
  width: 0%;
  height: 2px;
}
.btn-6-red:hover {
  color: rgb(255, 150, 150);
  background: transparent;
}
.btn-6-red:hover:before {
  height: 100%;
}
.btn-6-red:hover:after {
  width: 100%;
}
.btn-6-red span:before,
.btn-6-red span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgb(255, 80, 80);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6-red span:before {
  width: 2px;
  height: 0%;
}
.btn-6-red span:after {
  height: 2px;
  width: 0%;
}
.btn-6-red span:hover:before {
  height: 100%;
}
.btn-6-red span:hover:after {
  width: 100%;
}
</style>
